package pep;

import java.util.Random;

/**This class defines the operations of Identity nodes.*/
public class Identity extends Node{
 /**total amount of input*/
 public static double[] totInput = new double[Main.nSubjects];
 /**random number generator*/ private Random r = new Random();

 /**Creates a new Identity node.
  * @param subject Subject number used for static variable array.*/
 public Identity(int subject){
  super(subject);
  threshold = .5;
  strength = .8;
 }

 /**Updates activation for each cycle and searches responses.
  * @param stimNum Stimulus number.*/
 public void activate(int stimNum){
  //50% interference between nodes
  input -= ((totInput[subj]-activation)*.5);
  //add noise
  input += range((r.nextGaussian()*.2)+.5)*.01;
  update();
  //activate Response nodes
  if(activation>threshold){
   double output = (activation-threshold)*strength*1.4;
   Main.runs[subj].responses[stimNum].input += output;
  }
 }

 /**Clears total input for next cycle.
  * @param subject Subject number used for static variable array.*/
 public void sumAct(int subject){
  totInput[subject] += activation;
 }

 /**Clears total input for next cycle.
  * @param subject Subject number used for static variable array.*/
 public static void clear(int subject){
  totInput[subject] = 0;
 }

 /**Reinforces response connection.*/
 public void reinforce(){
  strength = (strength*.995) + (.00475);
 }
}